<?php
/**
 * Author: [ CopyLian ]
 * Date: [ 2017.02.23 ]
 * Email: [ copylian@aikehou.com ]
 * Site: [ http://www.copylian.com ]
 * Description [ 测试接口控制器 ]
 */
namespace app\wechat\controller;
use wechat\Wechat;
use wechat\WechatAuth;

class Test extends Base{

    //授权公众号前缀
    //private $prefix_account = 'many_'; //正式机
    private $prefix_account = ''; //测试机

    /**
     * [initialize 初始化]
     */
    public function initialize(){
        parent::initialize();
    }

    /**
     * [auth 测试第三方平台授权]
     */
    public function getauth(){
        if($this->request->isPost()){

            //获取参数
            $params = $this->request->param();

            //验证地址
            if(!isset($params['back_url']) || empty($params['back_url'])){
                $rdata['code'] = 0;
                $rdata['msg'] = lang('l_back_url_error');
                return $rdata;
            }

            //平台ID
            $platform_id = 2; //平台ID
            $state = 'test'; //重定向后会带上 state 参数、平台活动名称
            //$scope = 'snsapi_userinfo'; //授权作用域：snsapi_userinfo、snsapi_base
            $scope = 'snsapi_base'; //授权作用域：snsapi_userinfo、snsapi_base
            $back_url = $params['back_url']; //重定向URL
            $code = isset($params['code']) ? $params['code'] : '';

            //执行第三方的授权
            $Thirdplatform = new \app\wechat\controller\Thirdplatform();
            $data = $Thirdplatform->agent_thirdplatform_auth($platform_id, $state, $back_url, $scope, $code);
            return $data;
        }
    }

    /**
     * [getSign 测试第三方平台获取微信签名包]
     */
    public function getSign() {
        //获取参数
        $params = $this->request->param();

        //跨域
        if(isset($params['url'])){
            $url = $params['url'];
        } else{
            $url = 'https://h5test.ponyfamily.cn/wechat/index.html';
        }

        //设置分享数据缓存
        $cache_name = md5($url);
        $share_data = cache($cache_name);
        if(empty($share_data)){

            //平台ID
            $platform_id = 2; //平台ID
            $code = isset($params['code']) ? $params['code'] : '';

            //执行第三方的授权
            $Thirdplatform = new \app\wechat\controller\Thirdplatform();
            $share_data = $Thirdplatform->getSignPackage($platform_id, $url);

            //设置缓存
            cache($cache_name, $share_data, 7200);
        }

        //微信签名包
        $data['code'] = 1;
        $data['msg'] = lang('l_get_data_success');
        $data['data'] = $share_data;
        return json($data);
    }

    /**
     * [changePay 企业付款到零钱]
     */
    public function changePay() {
        
        //1、获取红包链接
        //实例化
        $WechatMmpaymk = new \wechat\WechatMmpaymk($this->prefix_account);

        //发送数据
        $send_data = [
            'amount'       => 60, //单位分
            'openid'       => 'oHL30wVEuI58Lgp8dkQmSSW4dU4g',
            'order_sn'     => create_order_sn(1, "qylq"),
            'desc'         => '企业付款到零钱',
            'check_name'   => 'NO_CHECK', //NO_CHECK：不校验真实姓名、FORCE_CHECK：强校验真实姓名
            're_user_name' => '', //收款用户真实姓名，如果check_name设置为FORCE_CHECK，则必填用户真实姓名
        ];
        
        //返回结果
        $res = $WechatMmpaymk->sendMoneyToChange($send_data);
        if($res['code'] == 0){
            $rdata['code'] = 0;
            $rdata['msg'] = $res['msg'];
            return json($rdata);
        } else if($res['code'] == 1){
            if($res['data']['return_code'] == 'SUCCESS' && $res['data']['result_code'] == 'SUCCESS'){
                $rdata['code'] = 1;
                $rdata['msg'] = '支付成功';
                $rdata['data'] = $res['data'];
                return json($rdata);
            } else {
                $rdata['code'] = 0;
                $rdata['msg'] = $res['data']['err_code_des'];
                $rdata['data'] = $res['data'];
                return json($rdata);
            }
        }
    }

    /**
     * [queryChangePay 查询企业付款到零钱]
     */
    public function queryChangePay() {
        
        //1、获取红包链接
        //实例化
        $WechatMmpaymk = new \wechat\WechatMmpaymk($this->prefix_account);

        //发送数据
        $send_data = [
            'order_sn'     => 'qylq00807115204001340'
        ];
        
        //返回结果
        $res = $WechatMmpaymk->queryChange($send_data);
        if($res['code'] == 0){
            $rdata['code'] = 0;
            $rdata['msg'] = $res['msg'];
            return json($rdata);
        } else if($res['code'] == 1){
            if($res['data']['return_code'] == 'SUCCESS' && $res['data']['result_code'] == 'SUCCESS'){
                $rdata['code'] = 1;
                $rdata['msg'] = '查询成功';
                $rdata['data'] = $res['data'];
                return json($rdata);
            } else {
                $rdata['code'] = 0;
                $rdata['msg'] = $res['data']['err_code_des'];
                $rdata['data'] = $res['data'];
                return json($rdata);
            }
        }
    }

    /**
     * [redPacketPay 发送红包]
     */
    public function redPacketPay() {
        
        //1、获取红包链接
        //实例化
        $WechatMmpaymk = new \wechat\WechatMmpaymk($this->prefix_account);

        //发送数据
        $send_data = [
            'amount'       => 30, //单位分
            'openid'       => 'oHL30wVEuI58Lgp8dkQmSSW4dU4g',
            'order_sn'     => create_order_sn(1, "qylq")
        ];
        
        //返回结果
        $res = $WechatMmpaymk->redPacketPay($send_data);
        if($res['code'] == 0){
            $rdata['code'] = 0;
            $rdata['msg'] = $res['msg'];
            return json($rdata);
        } else if($res['code'] == 1){
            if($res['data']['return_code'] == 'SUCCESS' && $res['data']['result_code'] == 'SUCCESS'){
                $rdata['code'] = 1;
                $rdata['msg'] = '支付成功';
                $rdata['data'] = $res['data'];
                return json($rdata);
            } else {
                $rdata['code'] = 0;
                $rdata['msg'] = $res['data']['err_code_des'];
                $rdata['data'] = $res['data'];
                return json($rdata);
            }
        }
    }

    /**
     * [queryRedPacket 查询现金红包]
     */
    public function queryRedPacket() {
        
        //1、获取红包链接
        //实例化
        $WechatMmpaymk = new \wechat\WechatMmpaymk($this->prefix_account);

        //发送数据
        $send_data = [
            'order_sn'     => 'qylq00807151840001406'
        ];
        
        //返回结果
        $res = $WechatMmpaymk->queryRedPacket($send_data);
        if($res['code'] == 0){
            $rdata['code'] = 0;
            $rdata['msg'] = $res['msg'];
            return json($rdata);
        } else if($res['code'] == 1){
            if($res['data']['return_code'] == 'SUCCESS' && $res['data']['result_code'] == 'SUCCESS'){
                $rdata['code'] = 1;
                $rdata['msg'] = '查询成功';
                $rdata['data'] = $res['data'];
                return json($rdata);
            } else {
                $rdata['code'] = 0;
                $rdata['msg'] = $res['data']['err_code_des'];
                $rdata['data'] = $res['data'];
                return json($rdata);
            }
        }
    }
}